<template>
  <main class="content">
    <div class="profile-wrapper">
      <form class="profile-info" @submit.prevent="changeProfile">
        <h5 class="mb-4 mb-lg-5">Персональная информация</h5>
        <base-input
          ref="email"
          v-model="controls.email"
          component="editable"
          type="email"
          placeholder="Почта пользователя"
          autocomplete="email"
        />
        <button class="btn-primary mt-5" type="submit" :disabled="loading">
          Сохранить изменения
        </button>
        <button class="btn-primary mt-5" @click.prevent="openPopupChangeNick">
          Сменить никнейм
        </button>
        <div class="subscribe-link mt-5">
          <div class="d-flex align-items-center mb-3">
            <input
              id="flexCheckDefault"
              v-model="controls.comments_confirm"
              type="checkbox"
            />
            <label class="form-check-label" for="flexCheckDefault">
              Подписаться на рассылку</label
            >
          </div>
          <div class="d-flex align-items-center">
            <input
              id="flexCheckChecked"
              v-model="controls.news_confirm"
              type="checkbox"
            />
            <label class="form-check-label" for="flexCheckChecked">
              Подписаться на комментарии</label
            >
          </div>
        </div>
      </form>
      <div class="profile-avatar">
        <h5 class="mb-4 mb-lg-5">Ваш аватар</h5>
        <div class="avatar-uploader">
          <base-avatar
            class="avatar-preview"
            :src="avatar"
            @click="() => $refs.avatarUploader.trigger()"
          />
          <base-input
            id="avatar"
            ref="avatarUploader"
            component="file"
            class="avatar-upload"
            placeholder="Загрузить фото"
            accept="image/*"
            @upload="controls.avatar = $event"
          />
        </div>
      </div>
    </div>
    <client-only>
      <popup-change-nick v-if="currentPopup" :username="controls.username" />
    </client-only>
  </main>
</template>

<script>
import email from 'vuelidate/lib/validators/email'
import required from 'vuelidate/lib/validators/required'
import { mapState } from 'vuex'
import PopupChangeNick from '@/components/popups/PopupChangeNick.vue'

import { TypesGlobal, TypesPopup } from '@/constants/store.types'
import { NICKNAME } from '@/constants/popups'

export default {
  name: 'UserPage',
  components: { PopupChangeNick },
  layout: 'user',
  data() {
    return {
      controls: { ...this.$store.state.auth.user },
    }
  },
  head() {
    return {
      title: this.$route.meta,
    }
  },
  computed: {
    avatar() {
      return typeof this.controls.avatar === 'object' &&
        this.controls.avatar !== null
        ? URL.createObjectURL(this.controls.avatar)
        : this.controls.avatar
    },
    ...mapState({
      loading: (state) => state.loading,
      currentPopup: (state) => state.popup.currentPopup === NICKNAME,
    }),
  },
  validations: {
    controls: {
      email: {
        email,
        required,
      },
      username: {
        required,
      },
    },
  },
  methods: {
    async changeProfile() {
      if (this.$v.$invalid) {
        if (this.$v.controls.email.$invalid && !this.$v.controls.email.email) {
          this.$store.dispatch(TypesGlobal.actions.SET_TIME_ERROR, {
            error: {
              email: 'Некорректный адрес',
            },
          })
        }
      } else {
        const changedUser = await this.$store.dispatch(
          'user/changeProfile',
          this.controls
        )
        this.controls = Object.assign({}, changedUser)
        this.$refs.email.setMode(false)
      }
    },
    openPopupChangeNick() {
      this.$store.commit(TypesPopup.mutations.OPEN_POPUP, NICKNAME)
    },
  },
}
</script>

<style lang="less" src="@/assets/style/pages/cabinet/index.less"></style>
